Index: serefpolicy-contrib-20140730/nscd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/nscd.if
+++ serefpolicy-contrib-20140730/nscd.if
@@ -1,8 +1,8 @@
-## <summary>Name service cache daemon.</summary>
+## <summary>Name service cache daemon</summary>
 
 ########################################
 ## <summary>
-##	Send generic signals to nscd.
+##	Send generic signals to NSCD.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -20,7 +20,7 @@ interface(`nscd_signal',`
 
 ########################################
 ## <summary>
-##	Send kill signals to nscd.
+##	Send NSCD the kill signal.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -38,7 +38,7 @@ interface(`nscd_kill',`
 
 ########################################
 ## <summary>
-##	Send null signals to nscd.
+##	Send signulls to NSCD.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -56,7 +56,7 @@ interface(`nscd_signull',`
 
 ########################################
 ## <summary>
-##	Execute nscd in the nscd domain.
+##	Execute NSCD in the nscd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -75,7 +75,8 @@ interface(`nscd_domtrans',`
 
 ########################################
 ## <summary>
-##	Execute nscd in the caller domain.
+##	Allow the specified domain to execute nscd
+##	in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -88,14 +89,13 @@ interface(`nscd_exec',`
 		type nscd_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, nscd_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Use nscd services by connecting using
-##	a unix domain stream socket.
+##	Use NSCD services by connecting using
+##	a unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -112,22 +112,17 @@ interface(`nscd_socket_use',`
 	allow $1 self:unix_stream_socket create_socket_perms;
 
 	allow $1 nscd_t:nscd { getpwd getgrp gethost };
-
 	dontaudit $1 nscd_t:fd use;
 	dontaudit $1 nscd_t:nscd { getserv shmempwd shmemgrp shmemhost shmemserv };
-
 	files_search_pids($1)
 	stream_connect_pattern($1, nscd_var_run_t, nscd_var_run_t, nscd_t)
 	dontaudit $1 nscd_var_run_t:file read_file_perms;
-
 	ps_process_pattern(nscd_t, $1)
 ')
 
 ########################################
 ## <summary>
-##	Use nscd services by mapping the
-##	database from an inherited nscd
-##	file descriptor.
+##	Use nscd services
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -135,28 +130,38 @@ interface(`nscd_socket_use',`
 ##	</summary>
 ## </param>
 #
-interface(`nscd_shm_use',`
+interface(`nscd_use',`
+	tunable_policy(`nscd_use_shm',`
+		nscd_shm_use($1)
+	',`
+		nscd_socket_use($1)
+	')
+')
+
+########################################
+## <summary>
+##	Do not audit attempts to write nscd sock files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`nscd_dontaudit_write_sock_file',`
 	gen_require(`
 		type nscd_t, nscd_var_run_t;
-		class nscd { getpwd getgrp gethost shmempwd shmemgrp shmemhost };
 	')
 
-	allow $1 self:unix_stream_socket create_stream_socket_perms;
-
-	allow $1 nscd_t:nscd { getpwd getgrp gethost shmempwd shmemgrp shmemhost };
-	allow $1 nscd_t:fd use;
-
-	files_search_pids($1)
-	stream_connect_pattern($1, nscd_var_run_t, nscd_var_run_t, nscd_t)
-	dontaudit $1 nscd_var_run_t:file read_file_perms;
+	dontaudit $1 nscd_t:sock_file write;
+	dontaudit $1 nscd_var_run_t:sock_file write;
 
-	allow $1 nscd_var_run_t:dir list_dir_perms;
-	allow $1 nscd_var_run_t:sock_file read_sock_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Use nscd services.
+##	Use NSCD services by mapping the database from
+##	an inherited NSCD file descriptor.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -164,18 +169,34 @@ interface(`nscd_shm_use',`
 ##	</summary>
 ## </param>
 #
-interface(`nscd_use',`
-	tunable_policy(`nscd_use_shm',`
-		nscd_shm_use($1)
-	',`
-		nscd_socket_use($1)
+interface(`nscd_shm_use',`
+	gen_require(`
+		type nscd_t, nscd_var_run_t;
+		class nscd { getserv getpwd getgrp gethost shmempwd shmemgrp shmemhost shmemserv };
 	')
+
+	allow $1 nscd_var_run_t:dir list_dir_perms;
+    allow $1 nscd_t:nscd { shmempwd shmemgrp shmemhost shmemserv };
+	# Receive fd from nscd and map the backing file with read access.
+	allow $1 nscd_t:fd use;
+
+	# cjp: these were originally inherited from the
+	# nscd_socket_domain macro. need to investigate
+	# if they are all actually required
+	allow $1 self:unix_stream_socket create_stream_socket_perms;
+
+	# dg: This may not be required.
+	allow $1 nscd_var_run_t:sock_file read_sock_file_perms;
+
+	stream_connect_pattern($1, nscd_var_run_t, nscd_var_run_t, nscd_t)
+	files_search_pids($1)
+	allow $1 nscd_t:nscd { getpwd getgrp gethost getserv };
+	dontaudit $1 nscd_var_run_t:file read_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to search
-##	nscd pid directories.
+##	Do not audit attempts to search the NSCD pid directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -193,7 +214,7 @@ interface(`nscd_dontaudit_search_pid',`
 
 ########################################
 ## <summary>
-##	Read nscd pid files.
+##	Read NSCD pid file.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -212,7 +233,7 @@ interface(`nscd_read_pid',`
 
 ########################################
 ## <summary>
-##	Unconfined access to nscd services.
+##	Unconfined access to NSCD services.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -244,20 +265,20 @@ interface(`nscd_unconfined',`
 ##	Role allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`nscd_run',`
 	gen_require(`
-		attribute_role nscd_roles;
+		type nscd_t;
 	')
 
 	nscd_domtrans($1)
-	roleattribute $2 nscd_roles;
+	role $2 types nscd_t;
 ')
 
 ########################################
 ## <summary>
-##	Execute the nscd server init
-##	script in the initrc domain.
+##	Execute the nscd server init script.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -275,8 +296,31 @@ interface(`nscd_initrc_domtrans',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an nscd environment.
+##	Execute nscd server in the nscd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`nscd_systemctl',`
+	gen_require(`
+		type nscd_unit_file_t;
+		type nscd_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 nscd_unit_file_t:file read_file_perms;
+	allow $1 nscd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, nscd_t)
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate 
+##	an nscd environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -285,7 +329,7 @@ interface(`nscd_initrc_domtrans',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the nscd domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -294,10 +338,14 @@ interface(`nscd_admin',`
 	gen_require(`
 		type nscd_t, nscd_log_t, nscd_var_run_t;
 		type nscd_initrc_exec_t;
+		type nscd_unit_file_t;
 	')
 
-	allow $1 nscd_t:process { ptrace signal_perms };
+	allow $1 nscd_t:process signal_perms;
 	ps_process_pattern($1, nscd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 nscd_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, nscd_initrc_exec_t)
 	domain_system_change_exemption($1)
@@ -310,5 +358,7 @@ interface(`nscd_admin',`
 	files_list_pids($1)
 	admin_pattern($1, nscd_var_run_t)
 
-	nscd_run($1, $2)
+	nscd_systemctl($1)
+	admin_pattern($1, nscd_unit_file_t)
+	allow $1 nscd_unit_file_t:service all_service_perms;
 ')
Index: serefpolicy-contrib-20140730/nscd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/nscd.te
+++ serefpolicy-contrib-20140730/nscd.te
@@ -1,36 +1,37 @@
-policy_module(nscd, 1.11.1)
+policy_module(nscd, 1.11.0)
 
 gen_require(`
 	class nscd all_nscd_perms;
 ')
 
-########################################
-#
-# Declarations
-#
-
 ## <desc>
 ##	<p>
-##	Determine whether confined applications
-##	can use nscd shared memory.
+##	Allow confined applications to use nscd shared memory.
 ##	</p>
 ## </desc>
 gen_tunable(nscd_use_shm, false)
 
-attribute_role nscd_roles;
+########################################
+#
+# Declarations
+#
 
+# cjp: this is out of order because of an
+# ordering problem with loadable modules
 type nscd_var_run_t;
 files_pid_file(nscd_var_run_t)
-init_daemon_pid_file(nscd_var_run_t, dir, "nscd")
 
+# nscd is both the client program and the daemon.
 type nscd_t;
 type nscd_exec_t;
 init_daemon_domain(nscd_t, nscd_exec_t)
-role nscd_roles types nscd_t;
 
 type nscd_initrc_exec_t;
 init_script_file(nscd_initrc_exec_t)
 
+type nscd_unit_file_t;
+systemd_unit_file(nscd_unit_file_t)
+
 type nscd_log_t;
 logging_log_file(nscd_log_t)
 
@@ -40,56 +41,58 @@ logging_log_file(nscd_log_t)
 #
 
 allow nscd_t self:capability { kill setgid setuid };
+allow nscd_t self:capability2 block_suspend;
 dontaudit nscd_t self:capability sys_tty_config;
 allow nscd_t self:process { getattr getcap setcap setsched signal_perms };
 allow nscd_t self:fifo_file read_fifo_file_perms;
-allow nscd_t self:unix_stream_socket { accept listen };
+allow nscd_t self:unix_stream_socket create_stream_socket_perms;
+allow nscd_t self:unix_dgram_socket create_socket_perms;
 allow nscd_t self:netlink_selinux_socket create_socket_perms;
+allow nscd_t self:tcp_socket create_socket_perms;
+allow nscd_t self:udp_socket create_socket_perms;
 
+# For client program operation, invoked from sysadm_t.
+# Transition occurs to nscd_t due to direct_sysadm_daemon. 
 allow nscd_t self:nscd { admin getstat };
 
-allow nscd_t nscd_log_t:file { append_file_perms create_file_perms setattr_file_perms };
+allow nscd_t nscd_log_t:file manage_file_perms;
 logging_log_filetrans(nscd_t, nscd_log_t, file)
 
+manage_dirs_pattern(nscd_t, nscd_var_run_t, nscd_var_run_t)
 manage_files_pattern(nscd_t, nscd_var_run_t, nscd_var_run_t)
 manage_sock_files_pattern(nscd_t, nscd_var_run_t, nscd_var_run_t)
-files_pid_filetrans(nscd_t, nscd_var_run_t, { file sock_file })
+files_pid_filetrans(nscd_t, nscd_var_run_t, { file sock_file dir })
 
+corecmd_search_bin(nscd_t)
 can_exec(nscd_t, nscd_exec_t)
 
-kernel_list_proc(nscd_t)
-kernel_read_kernel_sysctls(nscd_t)
 kernel_read_network_state(nscd_t)
+kernel_read_kernel_sysctls(nscd_t)
+kernel_list_proc(nscd_t)
 kernel_read_proc_symlinks(nscd_t)
 
-corecmd_search_bin(nscd_t)
-
 dev_read_sysfs(nscd_t)
 dev_read_rand(nscd_t)
 dev_read_urand(nscd_t)
 
-domain_search_all_domains_state(nscd_t)
-domain_use_interactive_fds(nscd_t)
-
-files_read_generic_tmp_symlinks(nscd_t)
-files_read_etc_runtime_files(nscd_t)
-
 fs_getattr_all_fs(nscd_t)
 fs_search_auto_mountpoints(nscd_t)
 fs_list_inotifyfs(nscd_t)
 
+# for when /etc/passwd has just been updated and has the wrong type
 auth_getattr_shadow(nscd_t)
 auth_use_nsswitch(nscd_t)
 
-corenet_all_recvfrom_unlabeled(nscd_t)
 corenet_all_recvfrom_netlabel(nscd_t)
 corenet_tcp_sendrecv_generic_if(nscd_t)
+corenet_udp_sendrecv_generic_if(nscd_t)
 corenet_tcp_sendrecv_generic_node(nscd_t)
-
-corenet_sendrecv_all_client_packets(nscd_t)
-corenet_tcp_connect_all_ports(nscd_t)
+corenet_udp_sendrecv_generic_node(nscd_t)
 corenet_tcp_sendrecv_all_ports(nscd_t)
-
+corenet_udp_sendrecv_all_ports(nscd_t)
+corenet_udp_bind_generic_node(nscd_t)
+corenet_tcp_connect_all_ports(nscd_t)
+corenet_sendrecv_all_client_packets(nscd_t)
 corenet_rw_tun_tap_dev(nscd_t)
 
 selinux_get_fs_mount(nscd_t)
@@ -98,16 +101,23 @@ selinux_compute_access_vector(nscd_t)
 selinux_compute_create_context(nscd_t)
 selinux_compute_relabel_context(nscd_t)
 selinux_compute_user_contexts(nscd_t)
+domain_use_interactive_fds(nscd_t)
+domain_search_all_domains_state(nscd_t)
+
+files_read_generic_tmp_symlinks(nscd_t)
+# Needed to read files created by firstboot "/etc/hesiod.conf"
+files_read_etc_runtime_files(nscd_t)
 
 logging_send_audit_msgs(nscd_t)
 logging_send_syslog_msg(nscd_t)
 
-miscfiles_read_localization(nscd_t)
 
 seutil_read_config(nscd_t)
 seutil_read_default_contexts(nscd_t)
 seutil_sigchld_newrole(nscd_t)
 
+sysnet_read_config(nscd_t)
+
 userdom_dontaudit_use_user_terminals(nscd_t)
 userdom_dontaudit_use_unpriv_user_fds(nscd_t)
 userdom_dontaudit_search_user_home_dirs(nscd_t)
@@ -121,13 +131,11 @@ optional_policy(`
 ')
 
 optional_policy(`
-	tunable_policy(`samba_domain_controller',`
-		samba_append_log(nscd_t)
-		samba_dontaudit_use_fds(nscd_t)
-	')
+	kerberos_use(nscd_t)
+')
 
-	samba_read_config(nscd_t)
-	samba_read_var_files(nscd_t)
+optional_policy(`
+    nis_authenticate(nscd_t)
 ')
 
 optional_policy(`
@@ -138,3 +146,20 @@ optional_policy(`
 	xen_dontaudit_rw_unix_stream_sockets(nscd_t)
 	xen_append_log(nscd_t)
 ')
+
+optional_policy(`
+	tunable_policy(`samba_domain_controller',`
+		samba_append_log(nscd_t)
+		samba_dontaudit_use_fds(nscd_t)
+	')
+')
+
+optional_policy(`
+	samba_read_config(nscd_t)
+	samba_read_var_files(nscd_t)
+    samba_stream_connect_nmbd(nscd_t)
+')
+
+optional_policy(`
+	unconfined_dontaudit_rw_packet_sockets(nscd_t)
+')
Index: serefpolicy-contrib-20140730/nsd.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/nsd.fc
+++ serefpolicy-contrib-20140730/nsd.fc
@@ -1,16 +1,13 @@
-/etc/rc\.d/init\.d/nsd	--	gen_context(system_u:object_r:nsd_initrc_exec_t,s0)
 
-/etc/nsd(/.*)?	gen_context(system_u:object_r:nsd_conf_t,s0)
-/etc/nsd/nsd\.db	--	gen_context(system_u:object_r:nsd_db_t,s0)
-/etc/nsd/primary(/.*)?	gen_context(system_u:object_r:nsd_zone_t,s0)
+/etc/nsd(/.*)?			gen_context(system_u:object_r:nsd_conf_t,s0)
+/etc/nsd/nsd\.db	--	gen_context(system_u:object_r:nsd_zone_t,s0)
+/etc/nsd/primary(/.*)?		gen_context(system_u:object_r:nsd_zone_t,s0)
 /etc/nsd/secondary(/.*)?	gen_context(system_u:object_r:nsd_zone_t,s0)
 
-/usr/sbin/nsd	--	gen_context(system_u:object_r:nsd_exec_t,s0)
-/usr/sbin/nsdc	--	gen_context(system_u:object_r:nsd_exec_t,s0)
+/usr/sbin/nsd		--	gen_context(system_u:object_r:nsd_exec_t,s0)
+/usr/sbin/nsdc		--	gen_context(system_u:object_r:nsd_exec_t,s0)
 /usr/sbin/nsd-notify	--	gen_context(system_u:object_r:nsd_exec_t,s0)
-/usr/sbin/zonec	--	gen_context(system_u:object_r:nsd_exec_t,s0)
-
-/var/lib/nsd(/.*)?	gen_context(system_u:object_r:nsd_zone_t,s0)
-/var/lib/nsd/nsd\.db	--	gen_context(system_u:object_r:nsd_db_t,s0)
+/usr/sbin/zonec		--	gen_context(system_u:object_r:nsd_exec_t,s0)
 
+/var/lib/nsd(/.*)?		gen_context(system_u:object_r:nsd_zone_t,s0)
 /var/run/nsd\.pid	--	gen_context(system_u:object_r:nsd_var_run_t,s0)
Index: serefpolicy-contrib-20140730/nsd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/nsd.if
+++ serefpolicy-contrib-20140730/nsd.if
@@ -1,8 +1,8 @@
-## <summary>Authoritative only name server.</summary>
+## <summary>Authoritative only name server</summary>
 
 ########################################
 ## <summary>
-##	Send and receive datagrams from NSD.  (Deprecated)
+##	Read NSD pid file.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -10,13 +10,18 @@
 ##	</summary>
 ## </param>
 #
-interface(`nsd_udp_chat',`
-	refpolicywarn(`$0($*) has been deprecated.')
+interface(`nsd_read_pid',`
+	gen_require(`
+		type nsd_var_run_t;
+	')
+
+	files_search_pids($1)
+	read_files_pattern($1, nsd_var_run_t, nsd_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Connect to NSD over a TCP socket  (Deprecated)
+##	Send and receive datagrams from NSD.  (Deprecated)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -24,47 +29,20 @@ interface(`nsd_udp_chat',`
 ##	</summary>
 ## </param>
 #
-interface(`nsd_tcp_connect',`
+interface(`nsd_udp_chat',`
 	refpolicywarn(`$0($*) has been deprecated.')
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an nsd environment.
+##	Connect to NSD over a TCP socket  (Deprecated)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-## <rolecap/>
 #
-interface(`nsd_admin',`
-	gen_require(`
-		type nsd_t, nsd_conf_t, nsd_var_run_t;
-		type nsd_initrc_exec_t, nsd_db_t, nsd_zone_t;
-	')
-
-	allow $1 nsd_t:process { ptrace signal_perms };
-	ps_process_pattern($1, nsd_t)
-
-	init_labeled_script_domtrans($1, nsd_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 nsd_initrc_exec_t system_r;
-	allow $2 system_r;
-
-	files_search_etc($1)
-	admin_pattern($1, { nsd_conf_t nsd_db_t })
-
-	files_search_var_lib($1)
-	admin_pattern($1, nsd_zone_t)
-
-	files_list_pids($1)
-	admin_pattern($1, nsd_var_run_t)
+interface(`nsd_tcp_connect',`
+	refpolicywarn(`$0($*) has been deprecated.')
 ')
Index: serefpolicy-contrib-20140730/nsd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/nsd.te
+++ serefpolicy-contrib-20140730/nsd.te
@@ -9,9 +9,7 @@ type nsd_t;
 type nsd_exec_t;
 init_daemon_domain(nsd_t, nsd_exec_t)
 
-type nsd_initrc_exec_t;
-init_script_file(nsd_initrc_exec_t)
-
+# A type for configuration files of nsd
 type nsd_conf_t;
 files_type(nsd_conf_t)
 
@@ -20,32 +18,28 @@ domain_type(nsd_crond_t)
 domain_entry_file(nsd_crond_t, nsd_exec_t)
 role system_r types nsd_crond_t;
 
-type nsd_db_t;
-files_type(nsd_db_t)
-
 type nsd_var_run_t;
 files_pid_file(nsd_var_run_t)
 
-type nsd_zone_t;
+# A type for zone files
+type nsd_zone_t alias nsd_db_t;
 files_type(nsd_zone_t)
 
 ########################################
 #
-# Local policy
+# NSD Local policy
 #
 
 allow nsd_t self:capability { chown dac_override kill setgid setuid };
 dontaudit nsd_t self:capability sys_tty_config;
 allow nsd_t self:process signal_perms;
+allow nsd_t self:tcp_socket create_stream_socket_perms;
+allow nsd_t self:udp_socket create_socket_perms;
 allow nsd_t self:fifo_file rw_fifo_file_perms;
-allow nsd_t self:tcp_socket { accept listen };
 
 allow nsd_t nsd_conf_t:dir list_dir_perms;
-allow nsd_t nsd_conf_t:file read_file_perms;
-allow nsd_t nsd_conf_t:lnk_file read_lnk_file_perms;
-
-allow nsd_t nsd_db_t:file manage_file_perms;
-filetrans_pattern(nsd_t, nsd_zone_t, nsd_db_t, file)
+read_files_pattern(nsd_t, nsd_conf_t, nsd_conf_t)
+read_lnk_files_pattern(nsd_t, nsd_conf_t, nsd_conf_t)
 
 manage_files_pattern(nsd_t, nsd_var_run_t, nsd_var_run_t)
 files_pid_filetrans(nsd_t, nsd_var_run_t, file)
@@ -62,7 +56,6 @@ kernel_read_kernel_sysctls(nsd_t)
 
 corecmd_exec_bin(nsd_t)
 
-corenet_all_recvfrom_unlabeled(nsd_t)
 corenet_all_recvfrom_netlabel(nsd_t)
 corenet_tcp_sendrecv_generic_if(nsd_t)
 corenet_udp_sendrecv_generic_if(nsd_t)
@@ -72,16 +65,17 @@ corenet_tcp_sendrecv_all_ports(nsd_t)
 corenet_udp_sendrecv_all_ports(nsd_t)
 corenet_tcp_bind_generic_node(nsd_t)
 corenet_udp_bind_generic_node(nsd_t)
-
-corenet_sendrecv_dns_server_packets(nsd_t)
 corenet_tcp_bind_dns_port(nsd_t)
 corenet_udp_bind_dns_port(nsd_t)
+corenet_sendrecv_dns_server_packets(nsd_t)
 
 dev_read_sysfs(nsd_t)
+dev_read_urand(nsd_t)
 
 domain_use_interactive_fds(nsd_t)
 
 files_read_etc_runtime_files(nsd_t)
+files_search_var_lib(nsd_t)
 
 fs_getattr_all_fs(nsd_t)
 fs_search_auto_mountpoints(nsd_t)
@@ -90,8 +84,6 @@ auth_use_nsswitch(nsd_t)
 
 logging_send_syslog_msg(nsd_t)
 
-miscfiles_read_localization(nsd_t)
-
 userdom_dontaudit_use_unpriv_user_fds(nsd_t)
 userdom_dontaudit_search_user_home_dirs(nsd_t)
 
@@ -105,23 +97,24 @@ optional_policy(`
 
 ########################################
 #
-# Cron local policy
+# Zone update cron job local policy
 #
 
+# kill capability for root cron job and non-root daemon
 allow nsd_crond_t self:capability { dac_override kill };
 dontaudit nsd_crond_t self:capability sys_nice;
 allow nsd_crond_t self:process { setsched signal_perms };
 allow nsd_crond_t self:fifo_file rw_fifo_file_perms;
+allow nsd_crond_t self:tcp_socket create_socket_perms;
+allow nsd_crond_t self:udp_socket create_socket_perms;
 
-allow nsd_crond_t nsd_t:process signal;
-ps_process_pattern(nsd_crond_t, nsd_t)
-
-allow nsd_crond_t nsd_conf_t:dir list_dir_perms;
 allow nsd_crond_t nsd_conf_t:file read_file_perms;
-allow nsd_crond_t nsd_conf_t:lnk_file read_lnk_file_perms;
 
-allow nsd_crond_t nsd_db_t:file manage_file_perms;
-filetrans_pattern(nsd_crond_t, nsd_zone_t, nsd_db_t, file)
+files_search_var_lib(nsd_crond_t)
+
+allow nsd_crond_t nsd_t:process signal;
+
+ps_process_pattern(nsd_crond_t, nsd_t)
 
 manage_files_pattern(nsd_crond_t, nsd_zone_t, nsd_zone_t)
 filetrans_pattern(nsd_crond_t, nsd_conf_t, nsd_zone_t, file)
@@ -133,27 +126,27 @@ kernel_read_system_state(nsd_crond_t)
 corecmd_exec_bin(nsd_crond_t)
 corecmd_exec_shell(nsd_crond_t)
 
-corenet_all_recvfrom_unlabeled(nsd_crond_t)
 corenet_all_recvfrom_netlabel(nsd_crond_t)
 corenet_tcp_sendrecv_generic_if(nsd_crond_t)
+corenet_udp_sendrecv_generic_if(nsd_crond_t)
 corenet_tcp_sendrecv_generic_node(nsd_crond_t)
-
-corenet_sendrecv_all_client_packets(nsd_crond_t)
-corenet_tcp_connect_all_ports(nsd_crond_t)
+corenet_udp_sendrecv_generic_node(nsd_crond_t)
 corenet_tcp_sendrecv_all_ports(nsd_crond_t)
+corenet_udp_sendrecv_all_ports(nsd_crond_t)
+corenet_tcp_connect_all_ports(nsd_crond_t)
+corenet_sendrecv_all_client_packets(nsd_crond_t)
 
 dev_read_urand(nsd_crond_t)
 
 domain_dontaudit_read_all_domains_state(nsd_crond_t)
 
 files_read_etc_runtime_files(nsd_crond_t)
+files_search_var_lib(nsd_t)
 
 auth_use_nsswitch(nsd_crond_t)
 
 logging_send_syslog_msg(nsd_crond_t)
 
-miscfiles_read_localization(nsd_crond_t)
-
 userdom_dontaudit_search_user_home_dirs(nsd_crond_t)
 
 optional_policy(`
Index: serefpolicy-contrib-20140730/nslcd.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/nslcd.fc
+++ serefpolicy-contrib-20140730/nslcd.fc
@@ -1,7 +1,4 @@
-/etc/nss-ldapd\.conf	--	gen_context(system_u:object_r:nslcd_conf_t,s0)
-
-/etc/rc\.d/init\.d/nslcd	--	gen_context(system_u:object_r:nslcd_initrc_exec_t,s0)
-
-/usr/sbin/nslcd	--	gen_context(system_u:object_r:nslcd_exec_t,s0)
-
-/var/run/nslcd(/.*)?	gen_context(system_u:object_r:nslcd_var_run_t,s0)
+/etc/nss-ldapd.conf	--	gen_context(system_u:object_r:nslcd_conf_t,s0)
+/etc/rc\.d/init\.d/nslcd --	gen_context(system_u:object_r:nslcd_initrc_exec_t,s0)
+/usr/sbin/nslcd		--	gen_context(system_u:object_r:nslcd_exec_t,s0)
+/var/run/nslcd(/.*)?		gen_context(system_u:object_r:nslcd_var_run_t,s0)
Index: serefpolicy-contrib-20140730/nslcd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/nslcd.if
+++ serefpolicy-contrib-20140730/nslcd.if
@@ -1,4 +1,4 @@
-## <summary>Local LDAP name service daemon.</summary>
+## <summary>nslcd - local LDAP name service daemon.</summary>
 
 ########################################
 ## <summary>
@@ -15,7 +15,6 @@ interface(`nslcd_domtrans',`
 		type nslcd_t, nslcd_exec_t;
 	')
 
-	corecmd_searh_bin($1)
 	domtrans_pattern($1, nslcd_exec_t, nslcd_t)
 ')
 
@@ -39,7 +38,7 @@ interface(`nslcd_initrc_domtrans',`
 
 ########################################
 ## <summary>
-##	Read nslcd pid files.
+##	Read nslcd PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -58,8 +57,25 @@ interface(`nslcd_read_pid_files',`
 
 ########################################
 ## <summary>
-##	Connect to nslcd over an unix
-##	domain stream socket.
+##	Dontaudit write to nslcd over an unix stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`nslcd_dontaudit_write_ock_file',`
+	gen_require(`
+		type nslcd_var_run_t;
+	')
+
+	dontaudit $1 nslcd_var_run_t:sock_file write;
+')
+
+########################################
+## <summary>
+##	Connect to nslcd over an unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -72,14 +88,33 @@ interface(`nslcd_stream_connect',`
 		type nslcd_t, nslcd_var_run_t;
 	')
 
-	files_search_pids($1)
 	stream_connect_pattern($1, nslcd_var_run_t, nslcd_var_run_t, nslcd_t)
+	files_search_pids($1)
+')
+
+#######################################
+## <summary>
+##  Do not audit attempts to write nslcd sock files
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain to not audit.
+##  </summary>
+## </param>
+#
+interface(`nslcd_dontaudit_write_sock_file',`
+    gen_require(`
+            type nslcd_t, nslcd_var_run_t;
+                ')
+
+    dontaudit $1 nslcd_t:sock_file write;
+    dontaudit $1 nslcd_var_run_t:sock_file write;
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an nslcd environment.
+##	All of the rules required to administrate
+##	an nslcd environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -99,17 +134,21 @@ interface(`nslcd_admin',`
 		type nslcd_conf_t;
 	')
 
-	allow $1 nslcd_t:process { ptrace signal_perms };
 	ps_process_pattern($1, nslcd_t)
+	allow $1 nslcd_t:process signal_perms;
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 nslcd_t:process ptrace;
+	')
 
+	# Allow nslcd_t to restart the apache service
 	nslcd_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 nslcd_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_etc($1)
+	files_list_etc($1)
 	admin_pattern($1, nslcd_conf_t)
 
-	files_search_pids($1)
-	admin_pattern($1, nslcd_var_run_t)
+	files_list_pids($1)
+	admin_pattern($1, nslcd_var_run_t, nslcd_var_run_t)
 ')
Index: serefpolicy-contrib-20140730/nslcd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/nslcd.te
+++ serefpolicy-contrib-20140730/nslcd.te
@@ -1,4 +1,4 @@
-policy_module(nslcd, 1.5.0)
+policy_module(nslcd, 1.4.1)
 
 ########################################
 #
@@ -20,12 +20,12 @@ files_config_file(nslcd_conf_t)
 
 ########################################
 #
-# Local policy
+# nslcd local policy
 #
 
-allow nslcd_t self:capability { setgid setuid dac_override };
-allow nslcd_t self:process signal;
-allow nslcd_t self:unix_stream_socket { accept listen };
+allow nslcd_t self:capability { chown dac_override setgid setuid sys_nice };
+allow nslcd_t self:process { setsched signal signull };
+allow nslcd_t self:unix_stream_socket create_stream_socket_perms;
 
 allow nslcd_t nslcd_conf_t:file read_file_perms;
 
@@ -36,14 +36,12 @@ files_pid_filetrans(nslcd_t, nslcd_var_r
 
 kernel_read_system_state(nslcd_t)
 
+dev_read_sysfs(nslcd_t)
+
 corenet_all_recvfrom_unlabeled(nslcd_t)
 corenet_all_recvfrom_netlabel(nslcd_t)
-corenet_tcp_sendrecv_generic_if(nslcd_t)
-corenet_tcp_sendrecv_generic_node(nslcd_t)
-
-corenet_sendrecv_ldap_client_packets(nslcd_t)
 corenet_tcp_connect_ldap_port(nslcd_t)
-corenet_tcp_sendrecv_ldap_port(nslcd_t)
+corenet_sendrecv_ldap_client_packets(nslcd_t)
 
 dev_read_sysfs(nslcd_t)
 
@@ -54,10 +52,14 @@ auth_use_nsswitch(nslcd_t)
 
 logging_send_syslog_msg(nslcd_t)
 
-miscfiles_read_localization(nslcd_t)
 
 userdom_read_user_tmp_files(nslcd_t)
 
 optional_policy(`
+	dirsrv_stream_connect(nslcd_t)
+')
+
+optional_policy(`
 	ldap_stream_connect(nslcd_t)
 ')
+
Index: serefpolicy-contrib-20140730/nsplugin.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/nsplugin.fc
@@ -0,0 +1,11 @@
+HOME_DIR/\.adobe(/.*)?			gen_context(system_u:object_r:nsplugin_home_t,s0)
+HOME_DIR/\.macromedia(/.*)?		gen_context(system_u:object_r:nsplugin_home_t,s0)
+HOME_DIR/\.gnash(/.*)?			gen_context(system_u:object_r:nsplugin_home_t,s0)
+HOME_DIR/\.gcjwebplugin(/.*)?		gen_context(system_u:object_r:nsplugin_home_t,s0)
+HOME_DIR/\.icedteaplugin(/.*)?		gen_context(system_u:object_r:nsplugin_home_t,s0)
+
+/usr/bin/nspluginscan	--	gen_context(system_u:object_r:nsplugin_exec_t,s0)
+/usr/bin/nspluginviewer	--	gen_context(system_u:object_r:nsplugin_exec_t,s0)
+/usr/lib/nspluginwrapper/npviewer.bin	--	gen_context(system_u:object_r:nsplugin_exec_t,s0)
+/usr/lib/nspluginwrapper/plugin-config	--	gen_context(system_u:object_r:nsplugin_config_exec_t,s0)
+/usr/lib/mozilla/plugins-wrapped(/.*)?			gen_context(system_u:object_r:nsplugin_rw_t,s0)
